/****************************************************************************
CToolsLib - Use-Case Library Trace Example
File: UCLib_CPTrace.c

This example demonstrates how to capture Common Platform (CP) trace with
the CTOOLS use case library and then use the CPU/EDMA to drain the contents 
of the Embedded Trace Buffer (ETB) or use an External receiver(560V2 
or TracePRO) for trace capture

For more details refer to ctools use case library Doxygen API reference

Copyright (c) 2009-2014 Texas Instruments Inc. (www.ti.com)
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:
1. Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.
3. The name of the author may not be used to endorse or promote products
   derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include "ctools_uclib.h"
#include "UCLib_CPTHelper.h"
#include "../../ETBLib/src/ti/edma_dev-c66xx.h"
#include "c6x.h"

/*******************************************************************************
 *    INSTRUCTIONS FOR DECODING BINARY TRACE DATA GENERATED BY THIS EXAMPLE
 *******************************************************************************
 *  - CP trace data gemerated is collected and stored in
 *    C:\temp\cpt_<sbp,slp,tbp,mbp,ep>_etbdata.bin
 *  - bin2tdf utility is required, located in:
 *    -> cd <CCS install dir>\ccs_base\emulation\analysis\bin
 *  - To convert binary trace data captured to TDF, use the following
 *     command line:
 *    -> bin2tdf -bin C:/temp/cpt_<sbp,slp,tbp,mbp,ep>_etbdata.bin -app C66X_0=<path to example.out>
 *    -procid stm -rcvr ETB -devicekey <device_specific_key, 0x0009E02F for C6678>
 *    -dcmfile C:\temp\cpt_<uc_name>_dcmdata.dcm -output C:\temp\cpt_<sbp,slp,tbp,mbp,ep>_etbdata.tdf
 *  - The cpt_<sbp,slp,tbp,mbp,ep>_etbdata.tdf file may be opened from the CCS menu Tools->
 *     Hardware Trace Analyzer->Open File...
 *  - For more details refer to: http://processors.wiki.ti.com/index.php/BIN2TDF
 *******************************************************************************
 ******************************************************************************/

#define DDR_START           0x80100000
#define MSMC_START          0x0C000000

#if defined(_66AK2Gxx)
#define EDMACC              (0)
#else
#define EDMACC              (2)
#endif

#define EDMA_CHANNEL        (0)
#define EDMA_PARAM          (100)

#define EDMA_ITERATIONS     (10)

#define GET_GLOBAL_ADDR(addr) \
    (uint32_t)(((uint32_t)(addr)) < (uint32_t)0x00900000 ? \
    ((uint32_t)(addr) | (uint32_t)((DNUM + 16) << 24)) : (uint32_t)(addr))

//CPU generates read/writes to system memory slaves with associated CP tracers
void CPU_generate_CPTActivity( int writeCnt, int readCnt, uint32_t addr )
{
    unsigned int i, n;
    int maxCnt = ( writeCnt >= readCnt ) ? writeCnt : readCnt;

    // Transfer words
    {
        volatile unsigned int locData;

        //fixed outer loop to extend data
        for ( n = 0; n < 10; n++ )
        {
            for( i=0; i < maxCnt; i++ )
            {
                unsigned int* pData = ( unsigned int* )( addr+i*4 );
                if ( i < readCnt ) locData = *pData;
                if ( i < writeCnt ) *pData = i;
            }
        }
    }

    // Transfer half words
    {
        volatile unsigned short locData;

        for( i=0; i < maxCnt; i++ )
        {
            unsigned short* pData = ( unsigned short* )( addr+i*4 );
            if ( i < readCnt )
            {
                locData = *pData;
                locData = *(pData+1);
            }

            // Wait a bit every 1K accesses
            if ( !( i % 512 ) )
            {
                int cnt = 0;
                while( cnt++ < 10000 );
            }

            if ( i < writeCnt )
            {
                *pData = i;
                *(pData+1) = (i & 0xffff0000) >> 16;
            }

        }

    }

    // Transfer bytes
    {
        volatile unsigned char locData;

        for( i=0; i < maxCnt; i++ )
        {
            unsigned char * pData = ( unsigned char* )( addr+i*4 );
            if ( i < readCnt )
            {
                locData = *pData;
                locData = *(pData+1);
                locData = *(pData+2);
                locData = *(pData+3);

            }
            if ( i < writeCnt )
            {
                *(pData+3) = ( i & 0xff000000 ) >> 24;
                *(pData+2) = ( i & 0x00ff0000 ) >> 16;
                *(pData+1) = ( i & 0x0000ff00 ) >> 8;
                *pData = ( i & 0x000000ff );

            }
        }

    }
}

//EDMA and CPU generates read/writes to system memory slaves with associated CP tracers
void Generate_CPTActivity(uint32_t src_addr, uint32_t dst_addr, uint16_t transfer_size, uint16_t transfer_count)
{
    uint32_t paramBase, i;
    uint32_t msmc_ddr_param;
    uint32_t ipr_value;
    uint8_t edma_channel;
    struct edma3_param param;

    edma_channel = EDMA_CHANNEL;

	EDMA3_DCHMAP_REG(EDMACC,edma_channel) = (EDMA_PARAM << 5); //EDMA CC0: Map param 100 to channel 0

	paramBase = EDMA_TPCC_PARAM_BASE_ADDR(EDMACC);

	msmc_ddr_param = paramBase + (0x20 * EDMA_PARAM);

    param.options   = (PARAM_OPT_TCINTEN | PARAM_OPT_TCC(edma_channel) | PARAM_OPT_AB_SYNC);
    param.src_addr  = GET_GLOBAL_ADDR(src_addr);
    param.ab_cnt    = (PARAM_BCNT(transfer_count) | PARAM_ACNT(transfer_size));
    param.dst_addr  = GET_GLOBAL_ADDR(dst_addr);
    param.srcdst_bidx = 0;
    param.link_bcnt = PARAM_LINK(0xFFFF); //Link to NULL
    param.srcdst_cidx = 0;
    param.ccnt        = 1;

    for(i=0; i<EDMA_ITERATIONS; i++)
    {
        /* Copy local structure to actual PaRAM memory locations */
        *(struct edma3_param *)msmc_ddr_param = param;

        if(edma_channel < 32)
        {
        	//Clear any pending EDMA completion interrupts
        	EDMA3_ICR_REG(EDMACC) = EDMA3_ICR_REG(EDMACC) | (1 << edma_channel);

        	//Manually trigger EDMA transfer
        	EDMA3_ESR_REG(EDMACC) = EDMA3_ESR_REG(EDMACC) | (1 << edma_channel);

        	//CPU generates read/write transactions to DDR3
        	CPU_generate_CPTActivity(0x100, 0x100, DDR_START);
        	//CPU generates read/write transactions to MSMC
        	CPU_generate_CPTActivity(0x100, 0x100, MSMC_START);

        	//Poll for EDMA transfer completion
        	do
        	{
        		ipr_value = EDMA3_IPR_REG(EDMACC);
        	}while((ipr_value & (1 << edma_channel)) == 0);
        }
        else if(edma_channel > 31)
        {
        	//Clear any pending EDMA completion interrupts
        	EDMA3_ICRH_REG(EDMACC) = EDMA3_ICRH_REG(EDMACC) | (1 << (edma_channel-32));

        	//Manually trigger EDMA transfer
        	EDMA3_ESRH_REG(EDMACC) = EDMA3_ESRH_REG(EDMACC) | (1 << (edma_channel-32));

        	//CPU generates read/write transactions to DDR3
        	CPU_generate_CPTActivity(0x100, 0x100, DDR_START);
        	//CPU generates read/write transactions to MSMC
        	CPU_generate_CPTActivity(0x100, 0x100, MSMC_START);

        	//Poll for EDMA transfer completion
        	do
        	{
        		ipr_value = EDMA3_IPRH_REG(EDMACC);
        	}while((ipr_value & (1 << (edma_channel-32))) == 0);
        }
    }

    //success
    return;
}

void main(void)
{
	//Start system memory profile
	if(SystemMemory_Profile_Start() < 0)
	{
		printf("System Memory profile start failed\n");
	}
	else
	{
		printf("System Memory profile start successful\n");
	}

	//Application generating system memory transactions

#if defined(EVENT_PROFILE)

	//A possible Application debug scenario: Capture spurious EDMA2 transactions to DDR3 within the range: 0x8000_0000 to 0x8000_0004
	//All EDMA2 transactions to DDR3 outside the range: 0x8000_0000 to 0x8000_0004 are valid
	//All CPU transactions to anywhere in the DDR3 are valid
	Generate_CPTActivity(MSMC_START, DDR_START, 4, 1);
	Generate_CPTActivity(MSMC_START+8, DDR_START+8, 4, 1);

#else

	//EDMA2 and CPU generates read/write transactions to MSMC/DDR3
	Generate_CPTActivity(MSMC_START, DDR_START, 4, 16384);

#endif

	//Stop system memory profile
	if(SystemMemory_Profile_Stop() < 0)
	{
		printf("System Memory profile stop failed\n");
	}
	else
	{
		printf("System Memory profile stop successful\n");
	}
}
